/**
 * Directive for plot widget
 *
 */
mod.directive('plotwidget', [

    'ux-controls.services.$dom',
    'plugin-plotWidget.services.$plotHighchart',

    function ($dom, $plotHighchart) {
        //resize end
        function resizeend(lmnt, args, scope) {

            var $lmnt = $(lmnt[0]);
            var chart = $lmnt.highcharts();

            if (chart) {

                if (args.orientation === "h") {

                    chart.setSize(scope.column.pxlWidth, chart.containerHeight, false);
                }
                else {
                    chart.setSize(scope.column.pxlWidth, args.h, false);
                }
            }
        };

        return {

            priority: 0,
            replace: false,
            transclude: false,
            restrict: 'E',
            link: function ($scope, lmnt, attrs) {

                /**
                 * main function for rendering widget
                 *
                 * @param {Object} data - widget.queryResult or currentData object
                 * @param {Object} container - widget container
                 */

                // rendering handler
                function onRender(sender, args) {

                    $plotHighchart.render($scope, lmnt, args);
                    $scope.widget.trigger("domready");

                }

                //container re-size end
                function onResizeEnd(sender, args) {

                    resizeend(lmnt, args, scope);
                }

                $scope.widget.on("render", onRender);
                $scope.widget.on('resizeend', onResizeEnd);

                // registerind scope destroy
                $scope.$on('$destroy', function () {

                    // destroying highcharts
                    var chart = lmnt.data('hc');
                    if (defined(chart) && chart.options) {

                        chart.destroy();
                        lmnt.data('hc', undefined);
                        $(lmnt).empty();
                    }

                    // unregistering widget model events
                    $scope.widget.off('render', onRender);
                    $scope.widget.off('resizeend', onResizeEnd);
                });

                return;
            }
        };
    }]);