/**
 * Widget loader
 *
 */

prism.run([
    // DI dashboard factory
    '$dashboard-app',
    'dashboard-base.services.$defaults',
    '$jaql',
    'plugin-plotWidget.services.$data.plot',

    // using $df to register basic chart widgets
    function ($app, $dashboarddefaults, $jaql, $plot) {

        var defaultMask = {

            measure: function (widget, item) {
                // formatting growth with percentage
                if ($jaql.isGrowth(item)) {

                    return {

                        type: 'percent',
                        separated: true,
                        decimals: '1'
                    };
                }

                return {

                    type: 'number',
                    abbreviations: {
                        t: true,
                        b: true,
                        m: true,
                        k: true
                    },
                    separated: true,
                    decimals: 'auto'
                };
            }
        };

        var defaultSize = {

            minHeight: 96, //header
            maxHeight: 2048,
            minWidth: 128,
            maxWidth: 2048,
            height: 384,
            defaultWidth: 512
        };

        var styles = function () {
            return {
                legend: {
                    enabled: true,
                    position: 'bottom'
                },
                seriesLabels: {
                    enabled: false,
                    rotation: 0
                },
                xAxis: {
                    enabled: true,
                    ticks: true,
                    labels: {
                        enabled: true,
                        rotation: 0,
                        stepInterval: null
                    },
                    title: {
                        enabled: false
                    },
                    gridLines: true
                },
                yAxis: {
                    inactive: false,
                    enabled: true,
                    ticks: true,
                    labels: {
                        enabled: true,
                        rotation: 0,
                        stepInterval: null
                    },
                    title: {
                        enabled: false
                    },
                    min: null,
                    max: null,
                    gridLines: true

                },
                navigator: {
                    enabled: true
                },
                outliers: {
                    enabled: false
                },
                whisker: {
                    'whisker/iqr': true,
                    'whisker/extremums': false,
                    'whisker/deviation': false

                },
                dataLimits: {
                    seriesCapacity: 50,
                    categoriesCapacity: 100000
                }
            }
        };


        $app.registerWidget('chart/boxplot', {
            name: 'chart/boxplot',
            family: 'plotwidget',
            title: 'Box & whisker widget',
            defaultSubtype: 'boxplot/full',
            subtypes: ['boxplot/full', 'boxplot/hollow'],
            priority: 14,
            directive: {
                desktop: "plotwidget"
            },
            options: {
                dashboardFiltersMode: 'filter',
                selector: true,
                triggersDomready: true,
                autoUpdateOnEveryChange: true,
                drillToAnywhere: true
            },
            data: $plot.manifest(),
            style: styles(),
            sizing: defaultSize,
            mask: defaultMask,
            hideNoResults: false,
            noResultImg: '/plugins/plotWidget/resources/images/boxplot-no-results-big.svg',
            noResultImgSmall: '/plugins/plotWidget/resources/images/boxplot-no-results-small.svg',
            iconSmall: "/plugins/plotWidget/resources/images/boxplot_icon_sprite.png",
            styleEditorTemplate: '/plugins/plotWidget/views/style/style-editor-template.html'
        });

    }
]);


